starterControllers.controller('BrowseMainCtrl',
	['$scope', '$q', '$state', '$ionicLoading', 'DataSvc',
	function($scope, $q, $state, $ionicLoading, DataSvc) {

	_oz.deb('BrowseMainCtrl init', $state.params);

	$scope.catToTree = {};

	$scope.hiddenTip = function(tipid) {
		return DataSvc.TipIsSeen(tipid);
	};

	$scope.hideTip = function(tipid) {
		DataSvc.TipMarkAsSeen(tipid);
	};

    $scope.onReady = function() {
    };

    $scope.updateCounts = function() {
		$scope.refreshData();
	};

	$scope.refreshData = function() {
		$ionicLoading.show(_oz.waiting('Fetching categories'));

		$q.all({
	    	lookup: DataSvc.GetLookups()
	    }).then(function(results) {
	    	$ionicLoading.hide();

	    	$scope.mainCat = results.lookup.category.simpleTree;

	    	//
	    	// Construct a lookup from cat id to entry to make accumulating counts faster
	    	//
	    	_.each($scope.mainCat, function(cat) {
	    		cat.count = 0;
	    		$scope.catToTree[cat.id] = cat;

	    		_.each(cat.subCategoryList, function(subCat) {
	    			subCat.count = 0;
	    			$scope.catToTree[subCat.id] = subCat;
	    		});
	    	});

	    	$scope.mainCount = results.lookup.minimalIndex.length;

	    	_.each(results.lookup.minimalIndex, function(entry) {
	    		var catMain = $scope.catToTree[entry.C1], catSub;

	    		if (catMain) {
	    			catMain.count = catMain.count + 1;

	    			catSub = $scope.catToTree[entry.C2];

	    			if (catSub) {
	    				catSub.count = catSub.count + 1;
	    			} else {
	    				_oz.deb('no such subcat', entry.C2);
	    			}
	    		} else {
	    			_oz.deb('no such cat', entry.C1);
	    		}
	    	});

			$scope.$broadcast('scroll.refreshComplete');

	    	$scope.onReady();
	    }, function(reason) {
	    	_oz.deb('$q refreshData error', reason);
	    });
	};


	$scope.refreshData();

}]);