starterControllers.controller('BrowseSubCtrl',
	['$scope', '$ionicLoading', '$q', '$state', 'DataSvc',
	function($scope, $ionicLoading, $q, $state, DataSvc) {

	_oz.deb('BrowseSubCtrl init', $state.params);

	$scope.mainDescription = 'Everything';

	$scope.paramsToJson = function(source) {
		return angular.toJson(source);
	};

    $scope.onReady = function() {
    };

    $scope.persistContext = function(categoryId) {
        var contextId = 'BROWSECAT';

        var contextData = DataSvc.GetContextData();

        contextData.filterSettings.CATMAIN = categoryId;

        DataSvc.SetContextData(contextId, contextData);
    };

    $ionicLoading.show(_oz.waiting('Fetching categories'));

    $q.all({
    	lookup: DataSvc.GetLookups()
    }).then(function(results) {
    	$ionicLoading.hide();

		$scope.simpleTree = results.lookup.category.simpleTree;

    	$scope.mainCatId = $state.params.mainCatId;

    	$scope.mainCat = _.find($scope.simpleTree, {id: $scope.mainCatId});

    	$scope.mainDescription = $scope.mainCat.description;
    	$scope.subCount = $scope.mainCat.count;

    	$scope.onReady();
    }, function(reason) {
        _oz.deb('$q BrowseSubCtrl error', reason);
    });

}]);