starterControllers.controller('LoginCtrl',
	['$scope', '$q', 'DataSvc', '$state', '$ionicLoading', '$ionicPopup',
	function($scope, $q, DataSvc, $state, $ionicLoading, $ionicPopup) {

	_oz.deb('LoginCtrl init', $state.params);

	$scope.loginDetail = {
		username: _oz.setting.username(),
		password: ''
	};

	$scope.changePasswordHref = _oz.setting.host() + '/JTIRA/JTIRA.aspx#!/login/login/' + _oz.setting.username();

	$scope.userInformation = {};

	$scope.destination = $state.params.destination || 'myaccount';

	$scope.loginUser = function() {
		$ionicLoading.show(_oz.waiting('Checking...'));

		$scope.errorMsg = [];

		DataSvc.Login($scope.loginDetail.username, $scope.loginDetail.password).then(function(result) {
			var failPopup;
			
			$ionicLoading.hide();

			if (result._jtiraResult === 'SUCCESS') {
				$state.go($scope.destination);
			} else {
				_oz.deb('loginresult', result);

				switch (result._jtiraResultCode) {
					case 'INVALID':
						failPopup = $ionicPopup.show(_oz.loginFailPopup($scope));

						failPopup.then(function(result) {
							var resetDestination;

							if (result === 'VISIT') {
								resetDestination = _oz.setting.host() + '/JTIRA/JTIRA.aspx#!/login/login?username=' + $scope.loginDetail.username;
								
								window.open(resetDestination, '_system');
							}
						});

						break;

					default:
						break;
				}

				return;
			}
		}, function(reason) {
			var failPopup;
			
			$ionicLoading.hide();

			failPopup = $ionicPopup.show(
				_oz.loginFailPopup(
					$scope, {
						subTitle: 'Error',

					}
				)
			);

			failPopup.then(function(result) {
				$state.go('top');
			});

		});
	};

}]);