starterControllers.controller('PictureViewerCtrl',
	['$scope', '$state', 'DataSvc',
	function($scope, $state, DataSvc) {

	_oz.deb('PictureViewerCtrl init', $state.params);

	$scope.backStyle = function(picUrl) {
		var escUrl, returnUrl;

		escUrl = picUrl.replace('(', '\\(');
		escUrl = escUrl.replace(')', '\\)');

		returnUrl = 'url(' + _oz.absUrl(escUrl) + '?preset=det-main)';
		_oz.deb('bs', returnUrl);
		return returnUrl;	
	};

	$scope.focusEpid = $state.params.epid;

	$scope.categoryCode = 'GENERAL';

	DataSvc.PopulateFullAd($scope.focusEpid).then(function(adDetail) {
		$scope.adDetail = adDetail;

		$scope.picData = [];

    	switch ($scope.adDetail.catMain.Code) {
    		case 'VEHICLES':
    		case 'BOATS':
    			$scope.categoryCode = 'VEHICLES';
    			break;

    		case 'JOBS':
    			$scope.categoryCode = 'JOBS';
    			break;

    		case 'PROPERTY':
    			$scope.categoryCode = 'PROPERTY';
    			break;

    		default:
    			break;
    	}

    	if ($scope.categoryCode !== 'PROPERTY') {
			_.each($scope.adDetail.FULL.ImageList, function(im) {
				if (im.URL) {
					$scope.picData.push(_oz.absUrl(im.URL));
				}
			});
    	}

		if ($scope.adDetail.FULL.AgentId && $scope.adDetail.FULL.AgentMediaPrefix) {
			_.each($scope.adDetail.FULL.Media.ImageList, function(propIm) {
				if (propIm.Image) {
					$scope.picData.push(_oz.absUrl($scope.adDetail.FULL.AgentMediaPrefix + propIm.Image));
				}
			});
			_.each($scope.adDetail.FULL.Media.FloorplanList, function(propIm) {
				if (propIm.Floorplan) {
					$scope.picData.push(_oz.absUrl($scope.adDetail.FULL.AgentMediaPrefix + propIm.Floorplan));
				}
			});
		} else {
			_.each($scope.adDetail.FULL.ImageList, function(im) {
				if (im.URL) {
					$scope.picData.push(_oz.absUrl(im.URL));
				}
			})

		}

		$scope.picData = _.unique($scope.picData);

		_oz.deb('picData', $scope.picData);
	});

}]);