starterControllers.controller('PostCtrl', function($scope, $cordovaCamera, $ionicLoading, $q, $state, DataSvc) {

	_oz.deb('PostCtrl init', $state.params);

	$scope.chosenCategory = {
		filter: ''
	};

	$scope.hiddenTip = function(tipid) {
		return DataSvc.TipIsSeen(tipid);
	};

	$scope.hideTip = function(tipid) {
		DataSvc.TipMarkAsSeen(tipid);
	};

	$scope.onReady = function() {
		$ionicLoading.show(_oz.waiting('Checking user'));

		DataSvc.RefreshUserInformation(true).then(function(userInformation) {
			$ionicLoading.hide();

			$scope.userInformation = userInformation;

			if ($scope.userInformation.IsLoggedIn !== true) {
				$state.go('top');

				return;
			}
		});
	};


	$scope.resetCategoryFilter = function() {
		_.each($scope.simpleTree, function(mainCat) {
			mainCat.hide = false;

			_.each(mainCat.subCategoryList, function(subCat) {
				subCat.hide = false;
			});
		})	    	
	};

	$scope.applyCategoryFilter = function() {
	    var searchList = $scope.chosenCategory.filter.toUpperCase().split(' ');
	    var anyMatch = false;
	    var anySubMatch = false;

	    searchList = _.filter(searchList, function(term) {return term.length > 2;});

	    //
	    // if there are no valid search terms, they're all shown
	    //
    	$scope.resetCategoryFilter();

	    if (searchList.length === 0) {
			return;
	    }

	    _.each($scope.simpleTree, function(mainCat) {
	    	var mainMatch = _.every(searchList, function(term) {
	    		return mainCat.description.toUpperCase().indexOf(term) !== -1;
	    	});

	    	//
	    	// If the main category matches, let all the subcategories stand
	    	//
	    	if (mainMatch === true) {
	    		anyMatch = true;
	    	} else {
	    		anySubMatch = false;

	    		_.each(mainCat.subCategoryList, function(subCat) {
	    			var subMatch = _.every(searchList, function(term) {
	    				return (mainCat.description.toUpperCase() + ' ' + subCat.description.toUpperCase()).indexOf(term) !== -1;
	    			});

	    			if (subMatch) {
	    				anyMatch = true;
	    				anySubMatch = true;
	    			} else {
	    				subCat.hide = true;
	    			}
	    		});

	    		if (anySubMatch === false) {
	    			mainCat.hide = true;
	    		}
	    	}

	    })

    	//
    	// If there were no matches, just show everything again
    	//
    	if (anyMatch === false) {
    		$scope.resetCategoryFilter();
    	}

	};

    $q.all({
    	lookup: DataSvc.GetLookups()
    }).then(function(results) {
		$scope.simpleTree = _.cloneDeep(results.lookup.category.simpleTree);

    	$scope.currentState = $state.current.name;

    	switch ($scope.currentState) {
    		case 'post-choosemaincat':
    			$scope.mainCatList = $scope.simpleTree;
    			break;

    		case 'post-choosesubcat':
    			$scope.mainCatId = $state.params.mainCatId;
    			$scope.mainCat = _.find($scope.simpleTree, {id: $scope.mainCatId});
    			break;
    	}

    	$scope.onReady();
    }, function(reason) {
    	_oz.deb('$q PostCtrl error', reason);
    });

});