starterControllers.controller('PublishCtrl',
	['$scope', '$q', '$state', '$filter', '$ionicPopup', '$ionicLoading', '$timeout', 'DataSvc',
	function($scope, $q, $state, $filter, $ionicPopup, $ionicLoading, $timeout, DataSvc) {

	_oz.deb('PublishCtrl init', $state.params);

	$scope.params = $state.params;
	$scope.epid = $scope.params.epid;


	$scope.isFirstPublish = function() {
		if (!$scope.epidAd) {
			return false;
		}		

		if ($scope.epidAd.ClassifiedState === 'SavedAndWaitingForPayment') {
			return true;
		}

		return false;
	};

	$scope.calculatedAdCost = function() {
		var pendingRate, selectedRate, adCost ;

		if (!$scope.epidAd) {
			return 0;
		}

		pendingRate = $scope.epidAd.JTIRAPricing.pendingRate;

		selectedRate = pendingRate.categoryPricing.RateList[pendingRate.categoryPricingIndex];

		adCost = selectedRate.Standard;

		if (pendingRate.extras.Featured === true) {
			adCost = adCost + selectedRate.Featured 
		}

		if (pendingRate.extras.Spotlight === true) {
			adCost = adCost + selectedRate.Spotlight;
		}

		return adCost / 100;
	};

	$scope.publishText = function() {
		var adCost = $scope.calculatedAdCost();

		if (adCost > 0) {
			return 'Pay and publish';
		} else {
			return 'Publish now';
		}
	};

	$scope.firstPublishText = function() {
		var adCost = $scope.calculatedAdCost();

		if (adCost > 0) {
			return 'You are about to publish your ad for the first time. It may take 15 minutes or so for your payment of ' +  $filter('adRate')(adCost, '£') + ' to be confirmed, after which your ad will start appearing in searches.';
		} else {
			return 'You are about to publish your FREE ad for the first time. It may take a few minutes to start appearing in searches.';
		}
	};

	$scope.renewalText = function() {
		var adCost = $scope.calculatedAdCost();

		return 'You are about renew your ad at a cost of ' +  $filter('adRate')(adCost, '£') + '. Please note you will be charged the full amount for this ad; no remaining days or credit will be carried over from any previous payment.';
	};

	$scope.publishAd = function() {
		$ionicLoading.show(_oz.waiting('Publishing ad'));

		DataSvc.PublishClassified($scope.epidAd, $scope.epidAd.ImageList).then(function(pubResult) {
			var alertPopup;
			var paymentDestination = _oz.setting.host() + '/JTIRA/JTIRA.aspx#!/ad-payment/';

			$ionicLoading.hide();

			_oz.deb('PublishClassified', pubResult);

			if (pubResult._jtiraResult === 'SUCCESS') {

				if (pubResult._jtiraResultCode === 'PUBLISHED') {
					alertPopup = $ionicPopup.alert({
				    	title: 'Ad published',
						template: 'Your ad has been published and will start appearing in results shortly.'
					});

					alertPopup.then(function(res) {
						$state.go('myaccount');
					});

					return;
				}

				if (pubResult._jtiraResultCode === 'NONFREE') {
					$state.go('basket', {newPaymentFlowReference: pubResult.PaymentFlowReference});

					return;
				}
			}


		});
	};

	$scope.onReady = function() {
	};

	$ionicLoading.show(_oz.waiting('Fetching ad'));

	$q.all({
		lookup: DataSvc.GetLookups(),
		epidAd: DataSvc.MyClassifiedDetail($scope.epid, true)
	}).then(function(results) {
		$ionicLoading.hide();

		$scope.lookup = results.lookup;
		$scope.epidAd = results.epidAd

		$scope.onReady();
	}, function(reason) {
    	_oz.deb('$q PublishCtrl error', reason);
    });
}]);