starterControllers.controller('SettingsCtrl',
	['$scope', '$ionicLoading', '$q', '$state', '$ionicPopup', '$cordovaSocialSharing', 'DataSvc',
	function($scope, $ionicLoading, $q, $state, $ionicPopup, $cordovaSocialSharing, DataSvc) {

	_oz.deb('SettingsCtrl init', $state.params);

    $scope.isAdmin = false;

    $scope.showAlert = function(templateText, gotoNext) {
       var alertPopup = $ionicPopup.alert({
         title: 'Done!',
         template: templateText
       });
       alertPopup.then(function(res) {
        if (gotoNext) {
            $state.go(gotoNext);
        }
       });
    };

    $scope.setting = _oz.setting;

    $scope.shareThisApp = function() {
        $scope.shareViaEmail();
    };

    $scope.showTermsAndConditions = function() {
        window.open('https://www.jtglobal.com/Jersey/Footer/Company-Information/Regulation/Terms--Conditions/', '_system');
    };

    $scope.showBannerAdvertising = function() {
        $scope.showExternalPage('general-content-page/117');
    };

    $scope.showCustomerSupport = function() {
        window.open('https://jtinsight.groovehq.com/help_center', '_system');
    };


    $scope.showExternalPage = function(pageName) {
        var destinationUrl = _oz.setting.host() + '/JTIRA/JTIRA.aspx#!/' + pageName;

        window.open(destinationUrl, '_system');
    };

    $scope.shareViaEmail = function() {
        var message, subject, toArr, bccArr, file;

        subject = 'JT Insight - Android App Available' ;

        message =
            'Hi there, I thought you might be interested in the new JT Insight Android app.  Its Jersey\’s only classifieds app and it\'s FREE!\r\n\r\n' + 
            _oz.setting.host() + '/JTIRA/JTIRA.aspx#!/general-content-page/337197' + '\r\n\r\n';

        $cordovaSocialSharing.shareViaEmail(message, subject, toArr, bccArr, file).then(function(result) {
            // Success! 
        }, function(err) {
            // An error occured. Show a message to the user
        });
    };

    $scope.resetTips = function() {
        DataSvc.TipResetAll();

        $scope.showAlert('The tips have been reset and will be shown again');
    };


    $scope.clearCategoryStats = function() {
        DataSvc.ClearCategoryStats();

        $scope.showAlert('Favourite categories have been set back to their defaults', 'top');
    };


    $scope.setPageLength = function(pageLength) {
        _oz.setting.defPageLength(pageLength);

        $scope.showAlert('Results have been set to ' + pageLength + ' per page', 'top');
    };


    $scope.flipEnvironment = function(newEnv) {
        DataSvc.Logout().then(function(result) {
            _oz.setting.env(newEnv);
            
            $scope.showAlert('Environment flipped to ' + newEnv + ' please pull-to-refresh and login again.', 'top')
        });
    };

    $scope.isSelectedPageLength = function(pageLength) {
        return (pageLength === _oz.setting.defPageLength());
    };

    DataSvc.RefreshUserInformation(true).then(function(result) {
        // console.log(result);
        if (result.IsLoggedIn !== true) {
            $scope.isAdmin = false;

            return;
        }

        $scope.isAdmin = (result.RoleAdmin === 'Y');
    });


    $scope.envList = _oz.setting.envList();

}]);