angular.module('starter.services', [])

//
// Sean Single DataSvc
//
.factory('DataSvc', function($q, $http, $filter) {
  var logUrl = _oz.setting.envList().UAT + '/jsonif.aspx';

  var qData = {}

  var adCache ;

  var tipsCache;

  var lookupsCache;
  var featuredAdCache;

  var resultListCache = {};

  var userDataCache;
  var userDataCacheIsCurrent = false;

  var userClassifiedCache;
  var userClassifiedIndex = {};
  var userClassifiedCacheIsCurrent = false;

  var jobAgencyListCache;

  var estateAgentListCache;

  var carDealersListCache;

  var resetData = function() {
    tipsCache = undefined;
    lookupsCache = undefined;
    featuredAdCache = undefined;
    userDataCache = undefined;
    userDataCacheIsCurrent = false;
    userClassifiedCache = undefined;
    userClassifiedIndex = {};
    userClassifiedCacheIsCurrent = false;
    jobAgencyListCache = undefined;
    estateAgentListCache = undefined;
    carDealersListCache = undefined;
  };

  var createClassified = function(category, pricing, detail, images) {
      var CreateClassifiedComplete = $q.defer();

      $http({
          method: 'POST',
          url: _oz.setting.dataUrl(),
          data: _oz.postData({
              service: 'USERCREATECLASSIFIED',
              category: angular.toJson(category),
              pricing: angular.toJson(pricing),
              detail: angular.toJson(detail),
              images: angular.toJson(images),
              appid: _oz.setting.appId()
          }),
          headers: _oz.setting.postHeaders()
      }).
      success(function(createResponse) {
          userClassifiedCacheIsCurrent = false;

          CreateClassifiedComplete.resolve(createResponse);
      }).
      error(function(data, status, headers, config) {
        _oz.deb('USERCREATECLASSIFIED error', data, status, headers(), config);

          CreateClassifiedComplete.reject(status);
      });

      return CreateClassifiedComplete.promise;
  };

  //
  // Each of these functions calls JSONIF and returns some structured data
  // via the promise they return.
  //
  // In the case of getPropertyLookups, this is a simple load from a JSON
  // formatted static file
  //
  var getMinimalIndex = function() {
        var minimalIndexLoaded = $q.defer();

        $http({
            method: 'POST',
            url: _oz.setting.dataUrl(),
            data: _oz.postData({service: 'MINIMALINDEX', appid: _oz.setting.appId()}),
            headers: _oz.setting.postHeaders()
        }).
        success(function(minimalIndex) {
          minimalIndexLoaded.resolve(minimalIndex);
        }).
        error(function(data, status, headers, config) {
          _oz.deb('MINIMALINDEX error', data, status, headers(), config);

            minimalIndexLoaded.reject(status);
        });

        return minimalIndexLoaded.promise;
  };

  var getCategoryTree = function() {
        var categoryTreeLoaded = $q.defer();

        $http({
            method: 'POST',
            url: _oz.setting.dataUrl(),
            data: _oz.postData({service: 'CATEGORYTREE', appid: _oz.setting.appId()}),
            headers: _oz.setting.postHeaders()
        }).
        success(function(categoryTree) {
          categoryTreeLoaded.resolve(categoryTree);
        }).
        error(function(data, status, headers, config) {
          _oz.deb('CATEGORYTREE error', data, status, headers(), config);

            categoryTreeLoaded.reject(status);
        });

        return categoryTreeLoaded.promise;
  };

  var getNewPricingSructure = function() {
      var pricingStructureLoaded = $q.defer();

      $http({
          method: 'POST',
          url: _oz.setting.dataUrl(),
          data: _oz.postData({service: 'NEWPRICINGSTRUCTURE', appid: _oz.setting.appId()}),
          headers: _oz.setting.postHeaders()
      }).
      success(function(pricingStructure) {
        pricingStructureLoaded.resolve(pricingStructure);
      }).
      error(function(data, status, headers, config) {
        _oz.deb('NEWPRICINGSTRUCTURE error', data, status, headers(), config);

          pricingStructureLoaded.reject(status);
      });

      return pricingStructureLoaded.promise;
  };

  var getPropertyLookups = function() {
      var propertyLookupsLoaded = $q.defer();

      $http({
          method: 'POST',
          url: _oz.setting.dataUrl(),
          data: _oz.postData({service: 'PROPERTYLOOKUPS', appid: _oz.setting.appId()}),
          headers: _oz.setting.postHeaders()
      }).
      success(function(propertyLookups) {
        propertyLookupsLoaded.resolve(propertyLookups);
      }).
      error(function(data, status, headers, config) {
        _oz.deb('PROPERTYLOOKUPS error', data, status, headers(), config);

          propertyLookupsLoaded.reject(status);
      });

      return propertyLookupsLoaded.promise;
  };


  //
  // Estate agents
  //
  var getEstateAgentList = function() {
      var estateAgentLoaded = $q.defer();

      if (estateAgentListCache) {
          estateAgentLoaded.resolve(estateAgentListCache);

          return estateAgentLoaded.promise;
      }

      $http({
          method: 'POST',
          url: _oz.setting.dataUrl(),
          data: _oz.postData({service: 'ESTATEAGENTLIST', appid: _oz.setting.appId()}),
          headers: _oz.setting.postHeaders()
      })
      .success(function(data) {
          estateAgentListCache = data;
          estateAgentLoaded.resolve(estateAgentListCache);
      }).
      error(function(data, status, headers, config) {
        _oz.deb('ESTATEAGENTLIST error', data, status, headers(), config);

          estateAgentLoaded.reject(status);
      });

      return estateAgentLoaded.promise;
  };


  //
  // Job Agencies
  //
  var getJobAgencyList = function() {
      var jobAgenciesLoaded = $q.defer();

      if (jobAgencyListCache) {
          jobAgenciesLoaded.resolve(jobAgencyListCache);

          return jobAgenciesLoaded.promise;
      }


      $http({
          method: 'POST',
          url: _oz.setting.dataUrl(),
          data: _oz.postData({service: 'JOBAGENCYLIST', appid: _oz.setting.appId()}),
          headers: _oz.setting.postHeaders()
      })
      .success(function(data) {
          jobAgencyListCache = data;
          jobAgenciesLoaded.resolve(jobAgencyListCache);
      }).
      error(function(data, status, headers, config) {
        _oz.deb('JOBAGENCYLIST error', data, status, headers(), config);

          jobAgenciesLoaded.reject(status);
      });

      return jobAgenciesLoaded.promise;
  };


  var getCarDealerList = function() {
    var carDealersLoaded = $q.defer();

    if (carDealersListCache) {
        carDealersLoaded.resolve(carDealersListCache);

        return carDealersLoaded.promise;
    }


      $http({
          method: 'POST',
          url: _oz.setting.dataUrl(),
          data: _oz.postData({service: 'CARDEALERLIST', appid: _oz.setting.appId()}),
          headers: _oz.setting.postHeaders()
      })
      .success(function(data) {
          carDealersListCache = data;
          carDealersLoaded.resolve(carDealersListCache);
      }).
      error(function(data, status, headers, config) {
        _oz.deb('CARDEALERLIST error', data, status, headers(), config);

          carDealersLoaded.reject(status);
      });

      return carDealersLoaded.promise;
  }


  var getLookups = function(forceRefresh) {
    var getLookupsLoaded = $q.defer();

    if (lookupsCache && (forceRefresh !== true)) {
      _oz.deb('return lookups from cache');
      getLookupsLoaded.resolve(lookupsCache);

      return getLookupsLoaded.promise;
    }

    adCache = {
        epidToAd: {},
        minimalindex: []
    };

    //
    // Ensure all importantlookups are retreived.
    // They are then batch processed and cross referenced once
    // in an attempt to make the more expensive rendering phase
    // as easy as possible
    //
    $q.all({
      minimalIndex: getMinimalIndex(),
      categoryTree: getCategoryTree(),
      pricingStructure: getNewPricingSructure(),
      propertyLookups: getPropertyLookups(),
      estateAgentList: getEstateAgentList(),
      jobAgencyList: getJobAgencyList(),
      carDealerList: getCarDealerList()
    }).then(function(qResult) {
      var catIdToCategory = {};
      var catCodeToCategory = {};
      var catTreeSimple = [], catTreeMain;
      var catMain, catSub, catMainId, catSubId;
      var propTenureLookup = {}, propSaleStatusLookup = {};
      var lastUpdate = new Date();

      //
      // Flatten out the category structure
      // to allow lookup by ID and by Code
      //
      for (catMainId in qResult.categoryTree) {
        if (qResult.categoryTree.hasOwnProperty(catMainId)) {

          catMain = qResult.categoryTree[catMainId];

          catTreeSimple.push({
            id: catMain.ID + '',
            description: catMain.Description,
            icon: _oz.setting.host() + catMain.Image,
            count: 0,
            subCategoryList: []
          });

          catTreeMain = catTreeSimple[catTreeSimple.length - 1];

          catIdToCategory[catMainId] = catMain;

          if (catMain.Code) {
            catCodeToCategory[catMain.Code] = catMain;
          };

          for (catSubId in catMain.SubCategoryList) {
            if (catMain.SubCategoryList.hasOwnProperty(catSubId)) {
              catSub = catMain.SubCategoryList[catSubId];
              catSub.parentCatId = catMainId;

              catTreeMain.subCategoryList.push({
                id: catSub.ID + '',
                description: catSub.Description,
                icon: _oz.setting.host() + ((catSub.Image !== '') ? catSub.Image : catMain.Image),
                count: 0
              });

              catIdToCategory[catSubId] = catSub;

              if (catSub.Code) {
                catCodeToCategory[catSub.Code] = catSub;
              }
            }
          }

          catTreeMain.subCategoryList = _.sortBy(catTreeMain.subCategoryList, function(subCat) {
            return subCat.description.toUpperCase();
          });
        }
      }

      catTreeSimple = _.sortBy(catTreeSimple, function(mainCat) {
        return mainCat.description.toUpperCase();
      });

      //
      // Flatten out property lookups
      //
      qResult.propertyLookups.Tenure.map(function(entry) {
        propTenureLookup[entry.ID] = entry;
      });

      qResult.propertyLookups.SaleStatus.map(function(entry) {
        propSaleStatusLookup[entry.ID] = entry;
      });

      //
      // With suitably fast lookups, cross reference the minimalindex in-situ
      //
      qResult.minimalIndex.map(function(entry) {
        //
        // Coerce category Id to strings for later consistency
        //
        entry.C1 += '';
        entry.C2 += '';

        entry.MIN = {
          P: entry.P,
          C1: entry.C1,
          C2: entry.C2,
          F: entry.F,
          dateActive: _oz.dateTime(entry.DA),
          lastUpdate: lastUpdate
        };

        //
        // Assign category details
        //
        entry.catMain = catIdToCategory[entry.C1];
        entry.catSub = catIdToCategory[entry.C2];

        //
        // Repository for pre-formatted values for display
        // These are filled on demand to ease the rendering phase
        //
        entry.formatted = {
          price: $filter('currencyInt')(entry.P, '£')
        };

        //
        // Any property lookups that may be present
        //
        if (entry.PTEN) {
          entry.propTenure = propTenureLookup[entry.PTEN];
        }

        if (entry.PSAL >= 0) {
          entry.propSaleStatus = propSaleStatusLookup[entry.PSAL];
        }

        //
        // And create a lookup from the epid to the ad detail
        // This will be useful for the async calls to fill in MED detail
        // behind the scenes
        //
        adCache.epidToAd[entry.id] = entry;

      });

      adCache.minimalIndex = qResult.minimalIndex;


      //
      // Return a useful subset of static data
      //
      lookupsCache = {
        category: {
          idToCategory: catIdToCategory,
          codeToCategory: catCodeToCategory,
          simpleTree: catTreeSimple
        },
        minimalIndex: qResult.minimalIndex,
        epidLookup: adCache.epidToAd,
        pricingData: qResult.pricingStructure,
        propertyData: qResult.propertyLookups,
        estateAgentList: qResult.estateAgentList,
        jobAgencyList: qResult.jobAgencyList,
        carDealerList: qResult.carDealerList
      };

      getLookupsLoaded.resolve(lookupsCache);
    });

    return getLookupsLoaded.promise;
  };


  //
  // Initially featured ads were determined by the server, as the data
  // had to be usable by dumb non-SPA apps, i.e. eligibility, sequence etc.
  // was determined centrally.
  //
  // Now done with a simple filter on client-side JS, but resolved with 
  // an instant promise for consistency
  //
  var getFeaturedAds = function(maxAds, forceRefresh) {
    var featuredAdsLoaded = $q.defer();

    if (featuredAdCache && !(forceRefresh === true)) {
      _oz.deb('getFeaturedAds return from cache');

      featuredAdsLoaded.resolve(featuredAdCache);

      return featuredAdsLoaded.promise;
    }

    //
    // I'll need access to all the lookup data
    // especially minimalindex to work
    // out which featured ads to return.
    //
    getLookups().then(function(result) {
      var featuredAds = [];

      result.minimalIndex.map(function(entry) {
        if (entry.F === 'Y') {
          featuredAds.push(entry);
        }
      });


      _oz.shuffle(featuredAds);

      featuredAdCache = featuredAds.slice(0, maxAds);

      featuredAdsLoaded.resolve(featuredAdCache);
    });

    return featuredAdsLoaded.promise;
  };


  //
  // Request that the MED property is populated for the chosen entries
  //
  // From a list of requested epids, retrieve potentially verbose information
  // and patch it into the ad cache.
  //
  // The list of epids that were actually updated is returned, not the new details.
  // Resolving the promise is a flag that the details should have been applied to
  // an already bound value, but the app view generally doesn't have to act on the
  // return value; if you've bound to one or more entries in the minimalindex
  // you can refer to these extra properties in your view, and it will be updated automatically.
  // You may still want to wait for this to return before you do *any* binding, in case you
  // want the display to be totally consistent before all the data is back (i.e. a "waiting" notice)
  //
  var populateMediumDetail = function(entries) {
      var mediumDetailLoaded = $q.defer();

      var missingList = [];
      var missingListString;

      //
      // If a MED entry doesn't exist, add it to the list to be retrieved
      //
      entries.map(function(entry) {
        if (entry) {
          if (!entry.MED) {
              missingList.push(entry.id);
          }
        }
      });

      //
      // Pass a single delimited string of all the epids requiring updated information
      //
      missingListString = missingList.join('|');

      if (missingListString !== '') {

          $http({
              method: 'POST',
              url: _oz.setting.dataUrl(),
              data: _oz.postData({service: 'MEDIUMINDEX', idlist:missingListString, appid: _oz.setting.appId()}),
              headers: _oz.setting.postHeaders()
          }).
          success(function(mediumList) {
              var imageList = [];
              var lastUpdate = new Date();

              //
              // Cross refer on the id, and append the new medium detail
              // entry to the original minimal object, storing the updated
              // entry for return
              //
              mediumList.map(function(mediumEntry) {
                  var ad = adCache.epidToAd[mediumEntry.id];

                  //
                  // SOLD at the start of the title is how a user flags it is sold
                  // again turn this into a flag to avoid complexity in rendering
                  //
                  if (mediumEntry.Title.indexOf('SOLD') === 0) {
                      mediumEntry.IsSold = true;
                  }

                  ad.formatted.title = $filter('drama')(mediumEntry.Title);

                  if (mediumEntry.Image) {
                    ad.formatted.listImage = _oz.absUrl(mediumEntry.Image + '?preset=app-list-sm');
                  } else {
                    ad.formatted.listImage = _oz.absUrl('/images/assets/no-image-' + ad.MIN.C1 + '.png?preset=app-list-sm');
                  }

                  ad.MED = mediumEntry;

                  ad.MED.lastUpdate = lastUpdate;

                  if (mediumEntry.Image) {
                      imageList.push(mediumEntry.Image + '?preset=grd-sm');
                  }
              });

              mediumDetailLoaded.resolve(missingList);
          }).
          error(function(data, status, headers, config) {
              _oz.deb('MEDIUMINDEX error', data, status, headers(), config);

              mediumDetailLoaded.reject(status);
          });
      } else {
          // _oz.deb('populateMediumDetail resolved from cache');
          mediumDetailLoaded.resolve(missingList);
      }

      return mediumDetailLoaded.promise;
  };



  //
  // populate the full detail attached to an existing ad
  // should never be called on it's own, a helper for 
  // the populateFullAd method
  //
  var populateFullDetail = function(epid) {
    var fullDetailLoaded = $q.defer();

    var searchId = epid.replace('epid-', '');

    $http({
        method: 'POST',
        url: _oz.setting.dataUrl(),
        data: _oz.postData({service:'GETPAGE', apid:searchId, appid: _oz.setting.appId()}),
        headers: _oz.setting.postHeaders()
    }).
    success(function(pageDetail) {
      var destination = adCache.epidToAd[epid];
      var lastUpdate = new Date();

      destination.FULL = pageDetail;
      destination.FULL.lastUpdate = lastUpdate;

      destination.formatted.description = $filter('safeDescription')(pageDetail.Description);

      fullDetailLoaded.resolve(destination);
    }).
    error(function(data, status, headers, config) {
        _oz.deb('GETPAGE error', data, status, headers(), config);

        fullDetailLoaded.reject(status);
    });

    return fullDetailLoaded.promise;
  }


  //
  // return the full ad details, loading and patching
  // any other required data as necessary
  //
  var populateFullAd = function(epid) {
    var fullAdLoaded = $q.defer();

    if (epid.indexOf('epid-') !== 0) {
      epid = 'epid-' + epid;
    }

    getLookups().then(function(result) {
      var testAd = result.epidLookup[epid];
      _oz.deb('populateFullAd testad', _.omit(testAd, 'catMain', 'catSub'));
      var missingList = [];
      var missingData = {};

      if (testAd) {
        if (!testAd.MED) {
          missingList.push(testAd);
          missingData.MED = populateMediumDetail(missingList);
        }

        if (!testAd.FULL) {
          missingData.FULL = populateFullDetail(epid);
        }
      }

      $q.all(missingData).then(function(results) {
        fullAdLoaded.resolve(testAd);
      });
    });

    return fullAdLoaded.promise;

  };

  var refreshUserInformation = function(forceUpdate) {
      var userDataLoaded = $q.defer();

      if (forceUpdate && forceUpdate === true) {
          userDataCacheIsCurrent = false;
      }

      if (userDataCacheIsCurrent) {
          //
          // If we believe there have been no changes
          // we just resolve from the cache.
          //
          userDataLoaded.resolve(userDataCache);
      } else {
        _oz.deb('refreshUserInformation forceUpdate', forceUpdate);
          $http({
              method: 'POST',
              url: _oz.setting.dataUrl(),
              data: _oz.postData({service: 'USERINFORMATION', appid: _oz.setting.appId()}),
              headers: _oz.setting.postHeaders()
          }).
          success(function(data) {
              //
              // Lists are strings of epids for space (meh)
              // Transparently convert to arrays for convenience
              //
              userDataCache = data;
              userDataCacheIsCurrent = true;

              if (userDataCache.FAVOURITES) {
                  userDataCache.FAVOURITES = userDataCache.FAVOURITES.split(',');
              } else {
                  userDataCache.FAVOURITES = [];
              }

              userDataLoaded.resolve(userDataCache);
          }).
          error(function(data, status, headers, config) {
              _oz.deb('USERINFORMATION error', data, status, headers(), config);

              userDataLoaded.reject(status);
          });
      }

      return userDataLoaded.promise;
  };

  var login = function(username, password) {
      var userLoginComplete = $q.defer();

      userDataCacheIsCurrent = false;

      $http({
          method: 'POST',
          url: _oz.setting.dataUrl(),
          data: _oz.postData({service:'USERLOGIN', Username:username, Password:password, appid: _oz.setting.appId()}),
          headers: _oz.setting.postHeaders()
      }).
      success(function(data) {
          userLoginComplete.resolve(data);
      }).
      error(function(data, status, headers, config) {
        _oz.deb('USERLOGIN error', data, status, headers(), config);

          userLoginComplete.reject(status);
      });

      return userLoginComplete.promise;
  };


  var logout = function() {
      //
      // Logout requested
      //

      //
      // Clear local caches to minimise history peeking
      //
      userClassifiedCache = null;
      userClassifiedCacheIsCurrent = false;
      userDataCache = {IsLoggedIn:false};
      userClassifiedCacheIsCurrent = false;

      var userLogoutComplete = $q.defer();

      $http({
          method: 'POST',
          url: _oz.setting.dataUrl(),
          data: _oz.postData({service:'USERLOGOUT', appid: _oz.setting.appId()}),
          headers: _oz.setting.postHeaders()
      }).
      success(function(data) {
          userLogoutComplete.resolve(data);
      }).
      error(function(data, status, headers, config) {
        _oz.deb('USERLOGOUT error', data, status, headers(), config);

          userLogoutComplete.reject(status);
      });

      return userLogoutComplete.promise;
  };


  var getUserAds = function(forceUpdate) {
      //
      // User's classified Ads
      //
      _oz.deb('user ad requested');
      var userClassifiedLoaded = $q.defer();

      if (userClassifiedCacheIsCurrent && !forceUpdate) {
        _oz.deb('resolving from cache');

          userClassifiedLoaded.resolve(userClassifiedCache);
      } else {
          _oz.deb('resolving from POST USERGETMYCLASSIFIEDLIST');
          $http({
              method: 'POST',
              url: _oz.setting.dataUrl(),
              data: _oz.postData({service:'USERGETMYCLASSIFIEDLIST', appid: _oz.setting.appId()}),
              headers: _oz.setting.postHeaders()
          }).
          success(function(fullAdList) {
            _oz.deb('success back from USERGETMYCLASSIFIEDLIST', fullAdList.length);
              
              if (fullAdList._jtiraResult === 'FAILURE') {
                userClassifiedLoaded.resolve(fullAdList);
                return;
              }

              //
              // Most components require a minimal->medium->full
              // structure to get going.
              // A user's own ads aren't wrapped this way as some
              // are inaccesible.
              // We nest calls and ensure they are all there
              // Because these records are ultimately derived from the
              // DB call and not Couch, the ID is slightly different
              //
              var standardAdList = [];

              _.each(fullAdList, function(fullAd) {
                  var minimal = {
                      id: 'epid-' + fullAd.ID,
                      MIN: {
                          P: fullAd.Price,
                          C1: fullAd.CatMain,
                          C2: fullAd.CatSub
                      },
                      MED: {
                          Image: fullAd.Image,
                          Title: fullAd.Title
                      },
                      FULL: fullAd
                  };

                  standardAdList.push(minimal);

                  userClassifiedIndex[minimal.id] = minimal;
              });

              userClassifiedCache = standardAdList;
              userClassifiedCacheIsCurrent = true;

              userClassifiedLoaded.resolve(userClassifiedCache);
          }).
          error(function(data, status, headers, config) {
            _oz.deb('USERGETMYCLASSIFIEDLIST error', data, status, headers(), config);
          
            userClassifiedLoaded.reject(status);
          });
      }

      return userClassifiedLoaded.promise;
  };

  var toggleFavourite = function(epid, action) {
      var favouriteToggled = $q.defer();

      var service;

      if (action) {
          if (action === 'REMOVE') {
              service = 'USERREMOVEFROMLIST';
          }
      } else {
          if (_.contains(userDataCache.FAVOURITES, epid)) {
              service = 'USERREMOVEFROMLIST';
          } else {
              service = 'USERADDTOLIST';
          }
      }

      $http({
          method: 'POST',
          url: _oz.setting.dataUrl(),
          data: _oz.postData({service:service, idlist:epid, ListName:'FAVOURITES', appid: _oz.setting.appId()}),
          headers: _oz.setting.postHeaders()
      }).
      success(function(newFavourites) {
          //
          // Flag the the details should be retrieved again
          //
          userDataCacheIsCurrent = false;
          favouriteToggled.resolve(newFavourites);
      }).
      error(function(data, status, headers, config) {
          _oz.deb('FAVOURITES error', data, status, headers(), config);

          favouriteToggled.reject(status);
      });

      return favouriteToggled.promise;
  };

  var search = function(term, categoryId) {
      var resultSetReturn = $q.defer();

        //
        // Retrieve a set of epid's matching the given search term
        //
        $http({
            method: 'POST',
            url: _oz.setting.dataUrl(),
            data: _oz.postData({service: 'ELASTICSEARCHTEXT', searchterm:term, appid: _oz.setting.appId()}),
            headers: _oz.setting.postHeaders()
        }).
        success(function(epidList) {
            //
            // Record the list of epid's matching the search term
            // This list is used a part of the filter applied to
            // the result set
            //
            _oz.deb('searchresult', epidList);

            resultSetReturn.resolve(epidList);
        }).
        error(function(data, status, headers, config) {
          _oz.deb('ELASTICSEARCHTEXT error', data, status, headers(), config);

            resultSetReturn.reject(status);
        });

        return resultSetReturn.promise;
  };

  var currentUserInformation = function() {
    var userInformationLoaded = $q.defer();

    userInformationLoaded.resolve(userDataCache);

    return userInformationLoaded.promise;
  };

  var myClassifiedDetail = function(epid, forceRefresh) {
    var myClassifiedLoaded = $q.defer();

    if (userClassifiedIndex[epid] && (forceRefresh !== true)) {
        myClassifiedLoaded.resolve(userClassifiedIndex[epid].FULL);
    } else {
        getUserAds().then(function(getAdResponse) {
            if (userClassifiedIndex[epid]) {
              myClassifiedLoaded.resolve(userClassifiedIndex[epid].FULL);
            } else {
              _oz.deb('myGetClassifiedDetail failed', getAdResponse);
              myClassifiedLoaded.resolve(getAdResponse);
            }
        });
    }

    return myClassifiedLoaded.promise;
  };


  var saveClassified = function(adDetails, imageList) {
      var saveClassifiedComplete = $q.defer();

      $http({
          method: 'POST',
          url: _oz.setting.dataUrl(),
          data: _oz.postData({
              service: 'USERSAVECLASSIFIED',
              detail: angular.toJson(adDetails),
              images: angular.toJson(imageList),
              appid: _oz.setting.appId()
          }),
          headers: _oz.setting.postHeaders()
      }).
      success(function(saveResponse) {
          userClassifiedCacheIsCurrent = false;

          saveClassifiedComplete.resolve(saveResponse);
      }).
      error(function(data, status, headers, config) {
          _oz.deb('USERSAVECLASSIFIED error', data, status, headers(), config);

          saveClassifiedComplete.reject(status);
      });

      return saveClassifiedComplete.promise;
  };



  var publishClassified = function(adDetails, imageList) {
      var publishClassifiedComplete = $q.defer();

      $http({
          method: 'POST',
          url: _oz.setting.dataUrl(),
          data: _oz.postData({
              service: 'USERPUBLISHCLASSIFIED',
              detail: angular.toJson(adDetails),
              images: angular.toJson(imageList),
              appid: _oz.setting.appId()
          }),
          headers: _oz.setting.postHeaders()
      }).
      success(function(publishResponse) {
          userClassifiedCacheIsCurrent = false;

          publishClassifiedComplete.resolve(publishResponse);
      }).
      error(function(data, status, headers, config) {
          _oz.deb('USERPUBLISHCLASSIFIED error', data, status, headers(), config);

          publishClassifiedComplete.reject(status);
      });

      return publishClassifiedComplete.promise;
  };

  var deleteClassified = function(epid) {
      var deleteClassifiedComplete = $q.defer();

      $http({
          method: 'POST',
          url: _oz.setting.dataUrl(),
          data: _oz.postData({
            service:'USERDELETEMYCLASSIFIED',
            apid:epid,
            appid: _oz.setting.appId()
          }),
          headers: _oz.setting.postHeaders()
      }).
      success(function(deleteResponse) {
          userClassifiedCacheIsCurrent = false;

          deleteClassifiedComplete.resolve(deleteResponse);
      }).
      error(function(data, status, headers, config) {
          _oz.deb('USERDELETEMYCLASSIFIED error', data, status, headers(), config);

          deleteClassifiedComplete.reject(status);
      });

      return deleteClassifiedComplete.promise;
  };


  var saveBase64File = function(base64Data, destinationFilename, epid, imageIndex) {
    var saveBase64FileComplete = $q.defer();

    $http({
        method: 'POST',
        url: _oz.setting.dataUrl(),
        data: _oz.postData({
            service: 'USERUPLOADBASE64FILE',
            base64Data: base64Data,
            filename: destinationFilename,
            epid: epid,
            imageIndex: imageIndex,
            appid: _oz.setting.appId()
        }),
        headers: _oz.setting.postHeaders()
    }).
    success(function(uploadResponse) {
        saveBase64FileComplete.resolve(uploadResponse);
    }).
    error(function(data, status, headers, config) {
          _oz.deb('USERUPLOADBASE64FILE error', data, status, headers(), config);

        saveBase64FileComplete.reject(status);
    });

    return saveBase64FileComplete.promise;
  };


  var sortResults = function(resultSet, sortOrder) {
      var sortedResultSet = resultSet;
      var dir = 1;
      var score;

      sortOrder = sortOrder || 'FEATURED';

      if (sortOrder === 'FEATURED') {
          sortedResultSet = _.sortBy(resultSet, function(ad) {
              score = 0;

              //
              // Featuredness then newness
              //
              score = ad.MIN.dateActive.getTime() / 60000 ;  // number of minutes

              score = score + ((ad.MIN.F === 'Y') ? 50000000 : 0);    // featured bonus

              return -score;
          });
      }

      if (sortOrder.indexOf('D') === 0) {
          dir = -1;
      }

      sortOrder = sortOrder.substring(1);

      if (sortOrder === 'PRICE') {
          sortedResultSet = _.sortBy(resultSet, function(ad) {
              if (dir === -1) {
                  return -ad.MIN.P;
              } else {
                  return ad.MIN.P;
              }
          });
      }


      if (sortOrder === 'ACTIVE') {
          sortedResultSet = _.sortBy(resultSet, function(ad) {
              if (dir === -1) {
                  return -ad.MIN.dateActive.getTime();
              } else {
                  return ad.MIN.dateActive.getTime();
              }
          });
      }

      return sortedResultSet;
  };


  var getTipsCache = function() {
    var tipsCacheData;

    if (!tipsCache) {
      tipsCacheData = window.localStorage['tipsCache'];

      if (tipsCacheData) {
        tipsCache = angular.fromJson(tipsCacheData);
      } else {
        tipsCache = {};
      }
    }

    return tipsCache;    
  };

  var setTipsCache = function(tips) {
    tipsCache = tips;

    window.localStorage['tipsCache'] = angular.toJson(tipsCache);
  }


  var tipMarkAsSeen = function(tipid) {
    var theTips = getTipsCache();

    tipid = _oz.setting.version() + tipid ;

    theTips[tipid] = true;

    setTipsCache(theTips);
  };

  var tipIsSeen = function(tipid) {
    var theTips = getTipsCache()

    tipid = _oz.setting.version() + tipid;

    if (theTips[tipid] === true || _oz.setting.showTips() !== true) {
      return true;
    } else {
      return false;
    }
  };

  var tipResetAll = function() {
    setTipsCache({});
  };

  var getResultList = function(searchTerm) {
    return resultListCache[searchTerm];
  };

  var addResultList = function(searchTerm, results) {
    resultListCache[searchTerm] = results;
  };

  var deleteResultList = function(searchTerm) {
    resultListCache.remove(searchTerm);

  };

  var getCachedResultList = function(searchTerm) {
    var cachedResultComplete = $q.defer();

    //
    // If no search term is specified, return all ads
    //
    if (!searchTerm) {
      getLookups().then(function(result) {
        var allAds = [];

        result.minimalIndex.map(function(entry) {
          allAds.push(entry.id);
        });

        cachedResultComplete.resolve(allAds)
      });

      return cachedResultComplete.promise;
    }

    if (getResultList(searchTerm)) {
      cachedResultComplete.resolve(getResultList(searchTerm));
    } else {
      search(searchTerm).then(function(searchResult) {
        addResultList(searchTerm, searchResult);

        cachedResultComplete.resolve(searchResult);
      });
    }

    return cachedResultComplete.promise;
  }

  var sortResults = function(resultSet, sortOrder) {
      var sortedResultSet = resultSet;
      var dir = 1;
      var score;

      if (!sortOrder || sortOrder === '_' || sortOrder === '') {
          sortOrder = 'FEATURED';
      }

      if (sortOrder === 'FEATURED') {
          sortedResultSet = _.sortBy(resultSet, function(ad) {
              score = 0;

              //
              // Featuredness then newness
              //
              score = ad.MIN.dateActive.getTime() / 60000 ;  // number of minutes

              score = score + ((ad.MIN.F === 'Y') ? 50000000 : 0);    // featured bonus

              return -score;
          });
      }

      if (sortOrder.indexOf('D') === 0) {
          dir = -1;
      }

      sortOrder = sortOrder.substring(1);

      if (sortOrder === 'PRICE') {
          sortedResultSet = _.sortBy(resultSet, function(ad) {
              if (dir === -1) {
                  return -ad.MIN.P;
              } else {
                  return ad.MIN.P;
              }
          });
      }


      if (sortOrder === 'ACTIVE') {
          sortedResultSet = _.sortBy(resultSet, function(ad) {
              if (dir === -1) {
                  return -ad.MIN.dateActive.getTime();
              } else {
                  return ad.MIN.dateActive.getTime();
              }
          });
      }

      return sortedResultSet;
  };


  var getContextData = function(contextDataId) {

    var contextDataCache, savedContextData;

    var defaultContextData = {
      originalParameters: {},
      filterSettings: {},
      cachedResultList: {},
      paging: {}
    } ;       

    if (!contextDataId) {
      return defaultContextData;
    }

    contextDataCache = angular.fromJson(window.localStorage['CONTEXTCACHE'] || '{}');

    savedContextData = contextDataCache[contextDataId];

    if (savedContextData) {
      return savedContextData;
    } else {
      return defaultContextData;
    }
  };


  var setContextData = function(contextDataId, contextData) {

    var contextDataCache = angular.fromJson(window.localStorage['CONTEXTCACHE'] || '{}');

    contextData.id = contextDataId;

    contextDataCache[contextDataId] = contextData;

    window.localStorage['CONTEXTCACHE'] = angular.toJson(contextDataCache);
  };


  var appLog = function(id, logData) {
    var appLogComplete = $q.defer();

    $http({
        method: 'POST',
        url: logUrl + '?id=' + id,
        data: _oz.postData({
            service: 'APPLOG',
            data: logData,
            appid: _oz.setting.appId()
        }),
        headers: _oz.setting.postHeaders()
    }).
    success(function(uploadResponse) {
        appLogComplete.resolve(uploadResponse);
    }).
    error(function(data, status, headers, config) {
      // no error logging, just live with it
        appLogComplete.reject(status);
    });

    return appLogComplete.promise;
  };

  var getCategoryStats = function() {
    var defStats = {
      numSamples: 0,
      topCategoryList: [],
      accumulatedStats: {}
    };

    var stats = angular.fromJson(window.localStorage['CATEGORYSTATS'] || '{}');

    if (!stats.numSamples) {
      stats = defStats;
    }

    return stats;
  };

  var setCategoryStats = function(stats) {
    window.localStorage['CATEGORYSTATS'] = angular.toJson(stats);

  };

  var updateCategoryStats = function(categoryId, weight) {
    var statsArray;
    var stats = getCategoryStats();

    weight = weight || 1;

    stats.accumulatedStats[categoryId] = stats.accumulatedStats[categoryId] ? stats.accumulatedStats[categoryId] + weight : weight;

    stats.numSamples = stats.numSamples + 1;

    //
    // Every 10 views, update the totals and work out if a new set of favourites is necessary
    //
    if ((stats.numSamples % 10) === 0) {
      //
      // Transform into a sortable array, and pick the top three
      //
      statsArray = [];
      
      _.each(stats.accumulatedStats, function(theValue, theCatId) {
        statsArray.push({
          id: theCatId,
          count: theValue
        })
      });

      statsArray = _.sortBy(statsArray, 'count');

      statsArray.reverse();

      statsArray = _.take(statsArray, 3);

      stats.topCategoryList = _.pluck(statsArray, 'id');
    }

    window.localStorage['CATEGORYSTATS'] = angular.toJson(stats);

    return stats;
  };

  var clearCategoryStats = function() {
    window.localStorage.removeItem('CATEGORYSTATS');
  };



  //
  // Basket related stuff
  //
  var getPaymentFlowDetails = function(flowRef) {
    //
    // Return the payment associated with a given flowRef
    // for display and confirmation
    //
    var detailsLoaded = $q.defer();

    $http({
        method: 'POST',
        url: _oz.setting.dataUrl(),
        data: _oz.postData({service: 'PMTGETFLOWDESCRIPTION', flowRef:flowRef, appid: _oz.setting.appId()}),
        headers: {'Content-Type': 'application/x-www-form-urlencoded'}
    }).
    success(function(flowDescription) {
        detailsLoaded.resolve(flowDescription);
    }).
    error(function(data, status, headers, config) {
        detailsLoaded.reject(status);
    });

    return detailsLoaded.promise;
};

  var getBasket = function(basketId) {
      var basketLoaded = $q.defer();

      $http({
          method: 'POST',
          url: _oz.setting.dataUrl(),
          data: _oz.postData({service: 'BASKETRETRIEVE', basketId: basketId, appid: _oz.setting.appId()}),
          headers: _oz.setting.postHeaders()
      }).
      success(function(currentBasket) {
          basketLoaded.resolve(currentBasket);
      }).
      error(function(data, status, headers, config) {
          basketLoaded.reject(status);
      });

      return basketLoaded.promise;
  };

  var getBasketCurrent = function() {
    var basketLoaded = $q.defer();

    $http({
        method: 'POST',
        url: _oz.setting.dataUrl(),
        data: _oz.postData({service: 'BASKETCURRENT', appid: _oz.setting.appId()}),
        headers: _oz.setting.postHeaders()
    }).
    success(function(currentBasket) {
        basketLoaded.resolve(currentBasket);
    }).
    error(function(data, status, headers, config) {
        basketLoaded.reject(status);
    });

    return basketLoaded.promise;
  };

  var addBasketEntry = function(basketId, flowRef) {
      var entryAdded = $q.defer();

      $http({
          method: 'POST',
          url: _oz.setting.dataUrl(),
          data: _oz.postData({service: 'BASKETADDENTRY', basketId: basketId, flowRef: flowRef, appid: _oz.setting.appId()}),
          headers: _oz.setting.postHeaders()
      }).
      success(function(currentBasket) {
          entryAdded.resolve(currentBasket);
      }).
      error(function(data, status, headers, config) {
          entryAdded.reject(status);
      });

      return entryAdded.promise;
  };

  var removeBasketEntry = function(basketId, flowRef) {
      var entryRemoved = $q.defer();

      $http({
          method: 'POST',
          url: _oz.setting.dataUrl(),
          data: _oz.postData({service: 'BASKETREMOVEENTRY', basketId: basketId, flowRef: flowRef, appid: _oz.setting.appId()}),
          headers: _oz.setting.postHeaders()
      }).
      success(function(currentBasket) {
          entryRemoved.resolve(currentBasket);
      }).
      error(function(data, status, headers, config) {
          entryRemoved.reject(status);
      });

      return entryRemoved.promise;
  };


  var makeDisplayEntry = function(basketEntryList) {
      var displayList = [];

      _.each(basketEntryList, function(entry) {
          var basketItem, adDescription, selectedRate, tariffDescription, entryCostInPence;

          basketItem = entry.basketEntry.TheCart.Items[0];

          adDescription = basketItem.Description.Title;

          selectedRate = basketItem.pendingRate.categoryPricing.RateList[basketItem.pendingRate.categoryPricingIndex];

          entryCostInPence = selectedRate.Standard;

          tariffDescription = selectedRate.Description + ' in ' + basketItem.Description.MainCat + ' / ' + basketItem.Description.SubCat;

          if (basketItem.pendingRate.extras.Featured === true) {
              tariffDescription = tariffDescription + ' +Featured';

              entryCostInPence = entryCostInPence + selectedRate.Featured;
          }

          if (basketItem.pendingRate.extras.Spotlight === true) {
              tariffDescription = tariffDescription + ' +Spotlight';

              entryCostInPence = entryCostInPence + selectedRate.Spotlight;
          }

          displayList.push({
              adDescription: adDescription,
              tariffDescription: tariffDescription,
              entryCost: entryCostInPence / 100,
              flowRef: entry.entryId,
              epid: basketItem.ID
          });
      });

      return displayList;
  };

  var extractStyle = function(basketEntry) {
      var basketItem = basketEntry.TheCart.Items[0];

      var selectedRate = basketItem.pendingRate.categoryPricing.RateList[basketItem.pendingRate.categoryPricingIndex];

      var tariffDescription = selectedRate.Description;

      if (basketItem.pendingRate.extras.Featured === true) {
          tariffDescription = tariffDescription + ' +Featured';
      }

      if (basketItem.pendingRate.extras.Spotlight === true) {
          tariffDescription = tariffDescription + ' +Spotlight';
      }

      return tariffDescription;
  };


  //
  // This final return effectively describes the public interface for the directive.
  // Every call returns a promise, even when referring to cached static data
  //
  // It's possible you could optimise to return the result immediately when you "know" the
  // cache is already populated, but easier to assume every request is asynch.
  //
  return {
    GetLookups: getLookups,
    GetFeaturedAds: getFeaturedAds,
    PopulateMediumDetail: populateMediumDetail,
    PopulateFullAd: populateFullAd,
    Login: login,
    Logout: logout,
    ToggleFavourite: toggleFavourite,
    ResetData: resetData,
    RefreshUserInformation: refreshUserInformation,
    CurrentUserInformation: currentUserInformation,
    GetUserAds: getUserAds,
    Search: search,
    SaveBase64Image: saveBase64File,
    SortResults: sortResults,
    CreateClassified: createClassified,
    MyClassifiedDetail: myClassifiedDetail,
    SaveClassified: saveClassified,
    PublishClassified: publishClassified,
    DeleteClassified: deleteClassified,
    TipResetAll: tipResetAll,
    TipMarkAsSeen: tipMarkAsSeen,
    TipIsSeen: tipIsSeen,
    TipList: getTipsCache,
    AddResultList: addResultList,
    GetResultList: getResultList,
    DeleteResultList: deleteResultList,
    GetCachedResultList: getCachedResultList,
    SortResults: sortResults,
    GetContextData: getContextData,
    SetContextData: setContextData,
    AppLog: appLog,
    GetCategoryStats: getCategoryStats,
    SetCategoryStats: setCategoryStats,
    UpdateCategoryStats: updateCategoryStats,
    ClearCategoryStats: clearCategoryStats,
    GetPaymentFlowDetails: getPaymentFlowDetails,
    GetBasket: getBasket,
    GetBasketCurrent: getBasketCurrent,
    AddBasketEntry: addBasketEntry,
    RemoveBasketEntry: removeBasketEntry,
    makeDisplayEntry: makeDisplayEntry,
    extractStyle: extractStyle
  };

});


;
